import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.io.*;
import javax.swing.filechooser.FileFilter;
import java.util.regex.*;
import java.util.*;
import java.lang.Object.*;
import java.lang.Math.*;

/**
* This class provides a few methods: 
*	-open and save files (pgm, ppm)
*	-draw image
*	-filtering for gray and color images
*
* @author Urs Pricking
* @version 1.5, 2003-12-17
*/
public class Filteroperationen extends JFrame implements ActionListener, ChangeListener, WindowListener {

	/** Constructor of Filteroperationen. */
	private Filteroperationen myFrame;
	/** A panel. */	 
	private JPanel main, p_original, p_filter, p_spinner; 
	/** An array to save the gray-values of the pixels. */
	private static int[][][] matrix1, matrix2, matrix3;	
	/** The menubar. */
	private JMenuBar menuBar;
	/** A menu of the menubar. */
	private JMenu datei, lineare_filter, rang_filter, glatt_filter, grad_filter, 			bilat_filter, optionen, fragezeichen, bilateral, median, minimum, maximum, 		mid_range, mittelwert, gauss;
	/** A Menuitem of a menu from the menubar. */
	private JMenuItem oeffnen, speichern, mittelwert3, mittelwert5, gauss3, gauss5, hochpass, h_sobel, 			v_sobel, laplace, schliessen, bilat3, bilat5, info, median3, minimum3, 			maximum3, mid_range3, median5, minimum5, maximum5, mid_range5, nicht_sym, nicht_mittel;
	/** The buttongroup which provides two radiobuttons (rb1, rb2). */
	private ButtonGroup group;
	/** A radiobutton for choosing whether the original or the filtered image is 	*   selected. */
	private JRadioButton rb1, rb2;
	/** The Slider for the threshold value. */
	private JSlider slider;
	/** A spinner for a standard deviation, which is used in bilateral filtering. */
	private JSpinner spinner_sigma_d,spinner_sigma_r; 
	/** The Filechooser. */
	private JFileChooser fc;
	/** The file which was chosen. */
	private File file;
	/** The scanner which is used to read the file. */
	private static StreamTokenizer scanner;
	/** The Magic Number of the file (pgm, ppm). */
	private String format = "";
	/** The width of the image (pixel). */
	private int breite;
	

/** The height of the image (pixel). */
	private int hoehe;
	/** The answer of a dialog (overwrite file). */
	private int frage;
	/** The maximum value of the file (value for white color). */
	private double maxwert = 0.0;
	/** Indicates whether the filechooser fc ic initialized or not. */
	private boolean choosed = false;	
	/** Indicates whether the image was threholded or not. */
	private boolean thresholded = false;	
	/** The standard deviation of pixels (bilateral filtering). */
	private int sigma_d = 20;
	/** The standard deviation of gray-values (bilateral filtering). */
	private	int sigma_r = 5;

	
	/**
	* Creates a new window with a menubar and its menuitems.
	* Also adds actionlistener to the menuitems.
	*/
	public Filteroperationen() {
		
		super("Filter");

		this.addWindowListener(this);
		menuBar = new JMenuBar();

		datei = new JMenu("Datei");
		oeffnen = new JMenuItem("Oeffnen");
		schliessen = new JMenuItem("Schliessen");
		datei.add(oeffnen);
		oeffnen.addActionListener(this);
		speichern = new JMenuItem("Filterbild speichern unter...");
		speichern.setEnabled(false);
		datei.add(speichern);
		datei.add(schliessen);
		schliessen.addActionListener(this);
		menuBar.add(datei);

		lineare_filter = new JMenu("lineare Filter");
		lineare_filter.setEnabled(false);	
		glatt_filter = new JMenu("Glaettungs-Filter");
		lineare_filter.add(glatt_filter);	
		grad_filter = new JMenu("Kanten-Filter");
		lineare_filter.add(grad_filter);	
		mittelwert = new JMenu("Mittelwert");
		glatt_filter.add(mittelwert);		
		mittelwert3 = new JMenuItem("3x3");
		mittelwert5 = new JMenuItem("5x5");
		mittelwert.add(mittelwert3);
		mittelwert.add(mittelwert5);
		gauss = new JMenu("Binomial");
		glatt_filter.add(gauss);
		gauss3 = new JMenuItem("3x3");
		gauss5 = new JMenuItem("5x5");
		gauss.add(gauss3);
		gauss.add(gauss5);
		//hochpass = new JMenuItem("Hochpass(3x3)");
		//lineare_filter.add(hochpass);
		h_sobel = new JMenuItem("horizontaler Sobel(3x3)");
		grad_filter.add(h_sobel);
		v_sobel = new JMenuItem("vertikaler Sobel(3x3)");
		grad_filter.add(v_sobel);
		laplace = new JMenuItem("Laplace(3x3)");
		grad_filter.add(laplace);
		nicht_sym = new JMenuItem("Verschiebungsinvarianz verletzt");
		lineare_filter.add(nicht_sym);
		nicht_mittel = new JMenuItem("Mittelwertseigenschaft verletzt");
		lineare_filter.add(nicht_mittel);	
		menuBar.add(lineare_filter);


		rang_filter = new JMenu("Rangordnungs-Filter");
		rang_filter.setEnabled(false);
		median = new JMenu("Median");
		median3 = new JMenuItem("3x3");
		median5 = new JMenuItem("5x5");
		median.add(median3);
		median.add(median5);
		rang_filter.add(median);
		minimum = new JMenu("Minimum");
		minimum3 = new JMenuItem("3x3");
		minimum5 = new JMenuItem("5x5");
		minimum.add(minimum3);
		minimum.add(minimum5);
		rang_filter.add(minimum);
		maximum = new JMenu("Maximum");
		maximum3 = new JMenuItem("3x3");
		maximum5 = new JMenuItem("5x5");
		maximum.add(maximum3);
		maximum.add(maximum5);
		rang_filter.add(maximum);
		mid_range = new JMenu("Mid-Range");
		mid_range3 = new JMenuItem("3x3");
		mid_range5 = new JMenuItem("5x5");
		mid_range.add(mid_range3);
		mid_range.add(mid_range5);
		rang_filter.add(mid_range);
		menuBar.add(rang_filter);		
		
		bilat_filter = new JMenu("Bilateral-Filter");
		bilat_filter.setEnabled(false);
		optionen = new JMenu("Einstellungen");
		bilat_filter.add(optionen);
		spinner_sigma_d = new JSpinner(new SpinnerNumberModel(3,1,100,1));
		spinner_sigma_r = new JSpinner(new SpinnerNumberModel(40,1,500,1));
		spinner_sigma_d.addChangeListener(this);
		spinner_sigma_r.addChangeListener(this);
	
		p_spinner = new JPanel();
		p_spinner.setLayout(new GridLayout(2,2));
		p_spinner.add(new JLabel("  sigma_d   "));
		p_spinner.add(new JLabel("  sigma_r   "));
		p_spinner.add(spinner_sigma_d);
		p_spinner.add(spinner_sigma_r);
		optionen.add(p_spinner);
		bilateral = new JMenu("bilateraler Gauss");
		bilat3 = new JMenuItem("3x3");
		bilat5 = new JMenuItem("5x5");
		bilateral.add(bilat3);
		bilateral.add(bilat5);
		bilat_filter.add(bilateral);
		menuBar.add(bilat_filter);
		
		fragezeichen = new JMenu("?");
		info = new JMenuItem("Info");
		fragezeichen.add(info);
		menuBar.add(fragezeichen);

		info.addActionListener(this);
		bilat3.addActionListener(this);
		bilat5.addActionListener(this);
		mittelwert3.addActionListener(this);
		mittelwert5.addActionListener(this);
		gauss3.addActionListener(this);
		gauss5.addActionListener(this);
		//hochpass.addActionListener(this);
		nicht_sym.addActionListener(this);
		nicht_mittel.addActionListener(this);
		h_sobel.addActionListener(this);
		v_sobel.addActionListener(this);
		laplace.addActionListener(this);
		median3.addActionListener(this);
		median5.addActionListener(this);	
		minimum3.addActionListener(this);
		minimum5.addActionListener(this);
		maximum3.addActionListener(this);
		maximum5.addActionListener(this);
		mid_range3.addActionListener(this);
		mid_range5.addActionListener(this);
		speichern.addActionListener(this);

		main = new JPanel();
		main.setLayout(null);
		setJMenuBar(menuBar);
		getContentPane().add(main);
	} // Meine Gui4()

	
	
	public void windowOpened(WindowEvent e) {
		System.out.println("-----------------------------");
        	System.out.println("|                           |");
       		System.out.println("|    RAUSCHUNTERDRUECKUNG   |");
       	 	System.out.println("|                           |");
       		System.out.println("|     erstellt von:         |");
       		System.out.println("|           Urs Pricking    |");
       		System.out.println("|                           |");
       		System.out.println("-----------------------------");
        }

        public void windowClosed(WindowEvent e) {}
        public void windowIconified(WindowEvent e) {}
        public void windowDeiconified(WindowEvent e) {}
        public void windowActivated(WindowEvent e) {}
        public void windowDeactivated(WindowEvent e) {}

        public void windowClosing(WindowEvent e) {
		System.out.println("Good bye!");
		System.exit(0);
        }

	
	/** 
	* Initialize a filechooser and returns if a file was selected or not.
	* If a file is selected, it is saved in the global variable "file".
	*
	* @param	b  Open-dialog or Save-dialog.
	* @return	Whether a file was selected or not.
	*/
	public boolean Datei_auswaehlen(boolean b) {
		
		if (!choosed) {
			fc = new JFileChooser();
			choosed = true;
		}

       		fc.setDialogTitle("DateiAuswahl");
        	
		fc.removeChoosableFileFilter(
   		    fc.getChoosableFileFilters()[0]);

		fc.setFileFilter(new FileFilter() {
			public boolean accept(File f) {
                  		return f.getName().toLowerCase().endsWith(".pgm") || f.getName().toLowerCase().endsWith(".ppm") || f.isDirectory();
              		}
              		public String getDescription() {
                   		 return "Bilder (*.pgm, *.ppm)";
              		}
          	 });	

    
		if (b) {
       			if (fc.showOpenDialog(null) == JFileChooser.APPROVE_OPTION) {
           			file = fc.getSelectedFile();
            			System.out.println();
				return(true);
        		}
			else {
				System.out.println();
				System.out.println("Keine Auswahl :-(");
				System.out.println();
				return(false);		
			}
		}
		else {
			if (fc.showSaveDialog(null) == JFileChooser.APPROVE_OPTION) {
           			file = fc.getSelectedFile();
				if (file.exists()) {
					String[] Optionen = {"Ja","Nein"};
     					 frage = JOptionPane.showOptionDialog(fc,"Datei 							existiert bereits. Datei 								ueberschreiben?","Abfrage",
                                                JOptionPane.YES_NO_OPTION,
                                                JOptionPane.QUESTION_MESSAGE,null,
                                                Optionen,Optionen[0]);
				}
				
	
	
			
            			System.out.println();
				System.out.println(file.getName() +":");
				return(true);
				
        		}
			else {
				System.out.println();
				System.out.println("Keine Auswahl :-(");
				System.out.println();
				return(false);		
			}
		}
	
	} // Datei_auswaehlen()



	/**
	* Reads format, width, height, maxwert from the global variable "file" 
	* and fills a matrix (int[][][] matrix1) with the grayscale-values from the file.
	* @throws	FileNotFoundException  Signals that an attempt to open the <code> file </code> denoted by a specified pathname has failed.
	* @throws	NumberFormatException  Thrown to indicate that the application has attempted to convert a string to one of the numeric types, but that the string does not have the appropriate format.
	* @throws	IOException  Signals that an I/O exception of some sort has occurred. 
	*			This class is the general class of exceptions produced by failed or interrupted I/O operations.
	*/
	public void Datei_einlesen() {

		try {
				scanner = new StreamTokenizer(new BufferedReader(new 								FileReader(file)));
				scanner.eolIsSignificant(false); 
				scanner.commentChar(35);
				scanner.nextToken();
				format = scanner.sval;
				scanner.nextToken(); 
				breite = (int) scanner.nval;
				scanner.nextToken();
				hoehe = (int) scanner.nval;
				scanner.nextToken();
				maxwert = scanner.nval;
				matrix1 = new int[hoehe][breite][3]; 
				matrix2 = new int[hoehe][breite][3];
				if (format.equals("P2")) {
					for (int i=0; i<hoehe; i++) {
						for (int j=0; j<breite; j++) {
							scanner.nextToken();
							for (int k=0; k<3; k++) {
								matrix1[i][j][k] = (int) 							(scanner.nval*(255/maxwert));
							}
						
						}
					}
				} // if
				else if (format.equals("P3")) {
					for (int i=0; i<hoehe; i++) {
						for (int j=0; j<breite; j++) {
							for (int k=0; k<3; k++) {
								scanner.nextToken();	
								matrix1[i][j][k] = (int) 							(scanner.nval*(255/maxwert));
							}
						
						}
					}
				} // else if
			System.out.println("	Datei: " +file.getName());
			System.out.println("	Format: " +format);
			System.out.println("	Breite: " +Integer.toString(breite));
			System.out.println("	Hoehe: " +Integer.toString(hoehe));
			System.out.println("	Maximaler Wert: " 						+Double.toString(maxwert));
			System.out.println();
			}


			catch ( FileNotFoundException f ) {
      			  	System.out.println( "File not found" );
      		  		f.printStackTrace( );
       			 	
    			}
			catch ( NumberFormatException f ) {
        			System.out.println( "Value not convetable into int: " + f );
        			f.printStackTrace( );
        			
  			} 
			catch ( IOException f ) {
        			System.out.println( "IO Error: " + f );
        			f.printStackTrace( );
       				
   			}
			
	} // Datei_einlesen()



	/**
	* Writes the values of the filtered image (int[][][]matrix2) in a new pgm- or ppm-file.
	*/
	public void Datei_schreiben() {
		try {	
		DataOutputStream dos = new DataOutputStream(new FileOutputStream(file));
		if (format.equals("P2")) {
			dos.writeBytes("P2");
		}
		else {
			dos.writeBytes("P3");
		}
		dos.writeBytes("\n");
		dos.writeBytes("# made by Urs Pricking");
		dos.writeBytes("\n");
		dos.writeBytes(Integer.toString(breite));
		dos.writeBytes(" ");
		dos.writeBytes(Integer.toString(hoehe));
		dos.writeBytes("\n");
		dos.writeBytes(Integer.toString((int)maxwert));
		dos.writeBytes("\n");
		for (int i=0; i<hoehe; i++) {
			for (int j=0; j<breite; j++) {
				if (format.equals("P2")) {	
					dos.writeBytes(Integer.toString(matrix2[i][j][0]));
					dos.writeBytes("\n");
				}
				else {
					for (int k=0; k<3; k++) {
						dos.writeBytes( 							Integer.toString(matrix2[i][j][k]));
						dos.writeBytes("\n");
					}
				}
			}
		}
		} // try
		catch ( IOException f ) {
        			System.out.println( "IO Error: " + f );
        			f.printStackTrace( );
       				
   		} // catch

	} // Datei_schreiben()


//-------------------------------Filter----------------------------------------------------

	

/**
	* Applies a Kernel (K) to the given matrix(matrix4) 
	* and returns the (linear) filtered matrix.
	*
	* @param	d  the result is divided by d.
	* @param	K  the Kernel of the linear filter.
	* @param	matrix4	the matrix to which the filter is applied to.
	* @return	the filtered matrix.
	*/
	public int[][][] LinearerFilter(int d, int[][] K, int[][][] matrix4) {
			int[][][] mat = new int[hoehe][breite][3];
			for (int i=0; i<hoehe; i++) {	
				for (int k=0; k<3; k++) {
					mat[i][0][k]=255;
					mat[i][breite-1][k]=255;
				}
			}				// Rand auf weiss setzen	
			for (int j=0; j<breite; j++) {
				for (int k=0; k<3; k++) {
					mat[0][j][k]=255;
					mat[hoehe-1][j][k]=255;
				}
			}		
						for (int i=1; i<hoehe-1; i++) {
				for (int j=1; j<breite-1; j++) {
					int[] sum;
					sum = new int[3];
					for (int m=0; m<3; m++) {
						sum[m]=0;
					}
					for (int k=i-1; k<i+2; k++) {
						for (int l=j-1; l<j+2; l++) {
							for (int m=0; m<3; m++) {
						sum[m]+=matrix4[k][l][m]*K[k-i+1][l-j+1];
							}
						}
					}
					for (int m=0; m<3; m++) {
						sum[m] = (int) ((double)sum[m])/d;

						if (sum[m]>=0 && sum[m]<=255) {
						   mat[i][j][m] = sum[m];
						}

						else if (sum[m]<0 && sum[m]>=-255) {
						   mat[i][j][m] = -1*sum[m]; //??
						}
						else if (sum[m]>255 || sum[m]<-255) {
						   mat[i][j][m] = 255;
						}

					}	
				}		
			}			


			return(mat);
	} // LinearerFilter()

	/**
	* Applies a horizontal and a vertical vector to the given matrix(matrix4)
	* and returns the filtered matrix.
	*
	* @param	matrix4	 the matrix to which the filter is applied to.
	* @param	hor  the horizontal filter-vector.
	* @param	vert  the vertical filter-vector.
	* @param	d_hor  the result of the horizontal filtering is divided by d_hor.
	* @param	d_vert  the reult of the vertical filtering is divided by d_vert.
	* @return	the filtered matrix.
	*/	
	public int[][][] Separabler_Filter(int[][][] matrix4, int[] hor, int[] vert, int d_hor, int d_vert) {			int abstand = (int)((hor.length-1)/2);			int[][][] mat = new int[hoehe][breite][3];
			for (int m=0; m<3; m++) {				for (int i=0; i<hoehe; i++) {
					for (int j=abstand; j<breite-abstand; j++) {
						int sum = 0;						for(int k=j-abstand; k<j+1+abstand; k++) {							sum+=(matrix4[i][k][m]*hor[k+abstand-j]);						}					mat[i][j][m]=(int)(sum/d_hor);					}				}				for (int i=abstand; i<hoehe-abstand; i++) {					for (int j=abstand; j<breite-abstand; j++) {						int sum = 0;						for (int k=i-abstand; k<i+1+abstand; k++) {							sum+=(mat[k][j][m]*vert[k+abstand-i]);						}							mat[i][j][m]=(int)(sum/d_vert);					}				}			}						for (int i=0; i<hoehe; i++) {	
				for(int j=0; j<abstand; j++) {
					for (int k=0; k<3; k++) {
						mat[i][j][k]=255;
						mat[i][breite-j-1][k]=255;
					}
				}
			}				// Randbetrachtung
			for (int j=0; j<breite; j++) {
				for(int i=0; i<abstand; i++) {
					for (int k=0; k<3; k++) {
						mat[i][j][k]=255;
						mat[hoehe-i-1][j][k]=255;
					}	
				}
			}
	return(mat);	}	/**
	* Applies a rank-filter, given by the type(typ), to the given matrix(matrix4)
	* and returns the filtered matrix.
	* 
	* @param	typ  the type of the rank-filter, e.g. minimum.
	* @param	matrix4  the matrix to which the filter is applied to.
	* @param	maske  the dimension of the filter(kernel).
	* @return	the filtered matrix.
	*/
	public int[][][] RangFilter(String typ, int[][][] matrix4, int maske) {

		int[][][] mat = new int[hoehe][breite][3];
		int abstand = (int)((maske-1)/2);
		int[][] array = new int[3][maske*maske];
		int[][] rand_oben = new int[breite][3];
		int[][] rand_unten = new int[breite][3];
		int[][] rand_links = new int[hoehe][3];
		int[][] rand_rechts = new int[hoehe][3];
		int[] ecke_links_oben = new int[3];
		int[] ecke_rechts_oben = new int[3];
		int[] ecke_links_unten = new int[3];
		int[] ecke_rechts_unten = new int[3];
		for (int m=0; m<3;m++) {
			ecke_links_oben[m]=matrix4[0][0][m];
			ecke_rechts_oben[m]=matrix4[0][breite-1][m];
			ecke_links_unten[m]=matrix4[hoehe-1][0][m];
			ecke_rechts_unten[m]=matrix4[hoehe-1][breite-1][m];
			for (int j=0; j<breite; j++) {
				rand_oben[j][m]=matrix4[0][j][m];
				rand_unten[j][m]=matrix4[hoehe-1][j][m];
			}
			for (int i=0; i<hoehe; i++) {
				rand_links[i][m]=matrix4[i][0][m];
				rand_rechts[i][m]=matrix4[i][breite-1][m];
			}
		}
		for (int i=0; i<hoehe; i++) {
			for (int j=0; j<breite; j++) {
						int count = 0;
				for (int k=i-abstand; k<i+abstand+1; k++) {	
					for (int l=j-abstand; l<j+abstand+1; l++) {
						for (int m=0; m<3; m++) {
							if (k<0 && l<0) {
								array [m][count] = ecke_links_oben[m];
							}
							else if (k<0 && l>=0 && l<breite) {								
								array [m][count] = rand_oben[l][m];
							}
							else if (k<0 && l>=breite) {
								array [m][count] = ecke_rechts_oben[m];
							}
							else if (k>=0 && k<hoehe && l<0) {
								array [m][count] = rand_links[k][m];
							}
							else if (k>=0 && k<hoehe && l>=breite) {
								array [m][count] = rand_rechts[k][m];
							}
							else if (k>=hoehe && l<0) {
								array [m][count] = ecke_links_unten[m];
							}
							else if (k>=hoehe && l>=0 && l<breite) {
								array [m][count] = rand_unten[l][m];
							}
							else if (k>=hoehe && l>=breite) {
								array [m][count] = ecke_rechts_unten[m];
							}
							else if (k>=0 && k<hoehe && l>=0 && l<breite) {
								array [m][count] = matrix4[k][l][m];
							}
						}
						count++;
					}
				}
				int mitte = (int) ((maske*maske-1)/2);
				for (int m=0; m<3; m++) {
					if (typ.equals("median")) {
						mat[i][j][m] = (Sort(array[m]))[mitte];
					}
					else if (typ.equals("minimum")) {
						mat[i][j][m] = (Sort(array[m]))[0];
					}
					else if (typ.equals("maximum")) {
						mat[i][j][m] = (Sort(array[m]))[mitte*2];
					}
					else if (typ.equals("mid_range")) {
						mat[i][j][m] = (int)((Sort(array[m]))[mitte*2]+(Sort(array[m]))[0])/2;
					}
				}
			}
		}			

		return(mat);		
	} // RangFilter()

	/**
	* Applies the thresholding-filter to the variable matrix3
	* and returns the filtered matrix.
	*
	* @param	schwellenwert  the threshold value.
	* @return	the filtered matrix.
	*/
	public int[][][] Threshold(int schwellenwert) {
		int [][][] mat = new int[hoehe][breite][3];
		for (int i=0; i<hoehe; i++) {
			for (int j=0; j<breite; j++) {
				for (int k=0; k<3; k++) {
					if (rb1.isSelected()) {
						if (matrix1[i][j][k]<=schwellenwert) {
							mat[i][j][k] = 0;
						}
						else {
							mat[i][j][k] = 255;
						}
					}
					else {
						if (matrix3[i][j][k]<=schwellenwert) {
							mat[i][j][k] = 0;
						}
						else {
							mat[i][j][k] = 255;
						}
					}
				}
			}
		}
	return(mat); 
	}
	
	/**
	* Apllies a bilateral filter to the given matrix
	* and returns the filtered matrix.
	*
	* @param	matrix4  the filtered matrix.
	* @param	maske  the dimension of the filter(kernel).
	* @return	the filtered matrix.
	*/	 	
	public int[][][] Bilateralfilter(int[][][] matrix4, int maske) {
		
		int[][][] ergebnis = new int[hoehe][breite][3];
		int abstand = (int)((maske-1)/2);

		double[] W_r = new double[256];
		for (int i=0; i<256; i++) {
			W_r[i] = java.lang.Math.exp((-(i*i))/(2*(sigma_r*sigma_r)));
		}

		double[][] W_d = new double[abstand+1][abstand+1];
		for (int i=0; i<abstand+1; i++) {
			for (int j=i; j<abstand+1;j++) {
				W_d[i][j]=W_d[j][i]=java.lang.Math.exp((-(i*i+j*j))/(2*(sigma_d*sigma_d)));
			}
		}


		for (int i=0; i<hoehe; i++) {	
			for(int j=0; j<abstand; j++) {
				for (int k=0; k<3; k++) {
					ergebnis[i][j][k]=255;
				       ergebnis[i][breite-j-1][k]=255;
				}
			}
		}				// Randbetrachtung
		for (int j=0; j<breite; j++) {
			for(int i=0; i<abstand; i++) {
				for (int k=0; k<3; k++) {
					ergebnis[i][j][k]=255;
					ergebnis[hoehe-i-1][j][k]=255;
				}
			}
		}
		
		for (int m=0; m<3; m++) {
			if (format.equals("P2") && (m == 1)) {
				for (int i=abstand; i<hoehe-abstand; i++) {
					for (int j=abstand; j<breite-abstand; j++) {
						ergebnis[i][j][1] = ergebnis[i][j][0];
						ergebnis[i][j][2] = ergebnis[i][j][0];
					} // for(j)
				} // for(i)
			break;
			} // if
		for (int i=abstand; i<hoehe-abstand; i++) {
			for (int j=abstand; j<breite-abstand; j++) {
				double sum = 0;
				double normalizer = 0;
				double w_d, w_r;			
				for (int k=i-abstand; k<i+abstand+1; k++) {	
					for (int l=j-abstand; l<j+abstand+1; l++) {
							if((i>=k) && (j>=l)) {
								w_d = W_d[i-k][j-l];
							}
							else if((i>=k) && (j<l)) {
								w_d = W_d[i-k][l-j];
							}
							else if((i<k) && (j>=l)) {
								w_d = W_d[k-i][j-l];
							}
							else {
								w_d = W_d[k-i][l-j];
							}	
							if (matrix4[k][l][m]>=matrix4[i][j][m]) {
								w_r = W_r[(matrix4[k][l][m]-matrix4[i][j][m])];
							}
							else {
								w_r = W_r[(matrix4[i][j][m]-matrix4[k][l][m])];
							}

							sum+= (w_d*w_r*matrix4[k][l][m]);
							normalizer+= (w_d*w_r);
					} // for(l)
				} // for(k)
				ergebnis[i][j][m] = (int) (sum/normalizer);
			} // for(j)
		} // for(i)
		} // for(m)				
	return(ergebnis);						
	} // Bilateralfilter()	

//-------------------------------Ende-Filter------------------------------------------------



	/**
	* Draws the original image (matrix1), the filtered image (matrix2),
	* the slider and the radiobuttons in the frame and resizes it.
	*/ 
	public void Zeichnen() {

		main.removeAll();
		setSize(2*breite+170, hoehe+150);

		slider = new JSlider(JSlider.VERTICAL, 0, 255, 127);
	  	slider.setMajorTickSpacing(50);
		slider.setMinorTickSpacing(10);
		slider.setPaintTicks(true);
		slider.setPaintLabels(true);
		slider.setBounds(100+2*breite, 50, 50, hoehe);
		slider.repaint();
		slider.addChangeListener(this);
		//slider.setVisible(false);
		main.add(slider);

		p_original = new JPanel() {
			public void paint(Graphics g) { 
				for (int i=0; i<hoehe; i++) {
      					for (int j=0; j<breite; j++) {									int[] grau;
						grau = new int[3];
						for (int k=0; k<3; k++) {									grau[k] = matrix1[i][j][k];
							g.setColor(new Color(grau[0],grau[1],grau[2]));
						}
						//g.drawRect(j,i, 0, 0);
						g.drawLine(j,i,j,i);
						
					} // for 2
				} // for 1
			} // paint() 
		};

		p_filter = new JPanel() {
			public void paint(Graphics g) { 
				for (int i=0; i<hoehe; i++) {
      					for (int j=0; j<breite; j++) {
						int[] grau;
						grau = new int[3];
						for (int k=0; k<3; k++) {
							grau[k] = matrix2[i][j][k];
						}
						g.setColor(new Color(grau[0],grau[1],grau[2]));
						//g.drawRect(j,i, 0, 0);
						g.drawLine(j,i,j,i);
						
					} // for 2
				} // for 1
			} // paint()
		};
		p_filter.setBounds(75+breite, 50, breite, hoehe);
		main.add(p_filter);
		
		p_original.setBounds(25, 50, breite, hoehe);
		main.add(p_original);

		//if (!enabled) {
			lineare_filter.setEnabled(true);
			rang_filter.setEnabled(true);
			speichern.setEnabled(true);
			bilat_filter.setEnabled(true);
		//	enabled = true;
		//}

		rb1 = new JRadioButton("Original filtern", true);
		rb1.setBounds(25, 80+hoehe, breite, 20);
		rb2 = new JRadioButton("Filterbild filtern", false);
		rb2.setBounds(75+breite, 80+hoehe, breite, 20);
		rb1.setActionCommand("original");
		rb2.setActionCommand("filterbild");
		
		group = new ButtonGroup();
		group.add(rb1);
		group.add(rb2);
		main.add(rb1);
		main.add(rb2);
		main.repaint();
		show();
		
	} // Zeichnen()



	/**
	* Sorts a vector by the size of its values
	* and returns the sorted vector.
	*
	* @param	a  the vector which has to be sort.
	* @return	the sorted vector.
	*/
	public int[] Sort(int[] a) {
        	int anz = a.length;
        	for (int i = 1; i < anz; i++) { 
            		for (int j = anz - 1; i <= j; j--) { 
                		if (a[j] < a[j - 1]) {
                    			int tmp = a[j];
                    			a[j] = a[j - 1];
                    			a[j - 1] = tmp;
                		}
			}
		}
	return(a);
    	}

	/**	
	* Adds two matrixes together
	* and returns the result.
	*
 	* @param	mat1  a matrix.
	* @param	mat2  a matrix.
	* @return	the result of the addition.
	*/
	public int[][][] Matrix_add(int[][][] mat1, int[][][] mat2) {
		int[][][] ergebnis = new int[hoehe][breite][3];
		for (int m=0; m<3; m++) {
			for (int i=0; i<hoehe; i++) {
				for (int j=0; j<breite; j++) {	
					ergebnis[i][j][m] = 										mat1[i][j][m]+mat2[i][j][m];
				} // for(j)
			} // for(i)
		} // for(m)
		return(ergebnis);
	} // Matrix_add()

	/**
	* Invoked when the state of a the slider or the two spinners is changed.
	*
	* @param	c  ChangeEvent is used to notify interested parties that state has changed in the event source.
	*/
	public void stateChanged(ChangeEvent c) {
		if (c.getSource() == slider) {
			int w = slider.getValue();
			if (!thresholded) {
				matrix3 = matrix2;
				thresholded = true;
			}
			matrix2 = Threshold(w);
			p_filter.repaint();
		}
		else if (c.getSource() == spinner_sigma_d || c.getSource() == 	spinner_sigma_r) {
			
			Object temp1 = spinner_sigma_d.getValue();
			Object temp2 = spinner_sigma_r.getValue();
			sigma_d = Integer.parseInt(temp1.toString());
			sigma_r = Integer.parseInt(temp2.toString());
			//System.out.println(Integer.toString(sigma_d) +" " 						+Integer.toString(sigma_r));
		}
	}

	/**
	* Invoked when an action occurs.
	*
	* @param 	e  A semantic event which indicates that a component-defined action occured.
	*/
	public void actionPerformed(ActionEvent e) {
				
                if (e.getSource() == mittelwert3) {
                        System.out.println("Mittelwert-Filter (3x3) angewendet");
			thresholded = false;
			int[] hor = new int[3];
			int[] vert = new int[3];
			for (int k=0; k<3; k++) {
				hor[k]=1;
			}
			vert = hor;
			if (rb1.isSelected()) {
				matrix2 = Separabler_Filter(matrix1, hor, vert, 3, 3);
			}
			else {
				matrix2 = Separabler_Filter(matrix2, hor, vert, 3, 3);
			}			
			p_filter.repaint();
			
                } // if
			else if (e.getSource() == mittelwert5) {
                        System.out.println("Mittelwert-Filter (5x5) angewendet");
			thresholded = false;
			int[] hor = new int[5];
			int[] vert = new int[5];
			for (int k=0; k<5; k++) {
				hor[k]=1;
			}
			vert = hor;
			if (rb1.isSelected()) {
				matrix2 = Separabler_Filter(matrix1, hor, vert, 5, 5);
			}
			else {
				matrix2 = Separabler_Filter(matrix2, hor, vert, 5, 5);
			}			
			p_filter.repaint();
		} // else if	
		else if (e.getSource() == gauss3) {
                        System.out.println("Gauss-Filter (3x3) angewendet");
			thresholded = false;
			int[] hor = new int[3];
			int[] vert = new int[3];
			hor[0] = hor[2] = 1;
			hor[1] = 2;
			vert = hor;
			if (rb1.isSelected()) {
				matrix2 = Separabler_Filter(matrix1, hor, vert, 4, 4);	
			}
			else {
				matrix2 = Separabler_Filter(matrix2, hor, vert, 4, 4);
			}			
			p_filter.repaint();
			
                } // else if
	
		else if (e.getSource() == gauss5) {
                        System.out.println("Gauss-Filter (5x5) angewendet");
			thresholded = false;
			int[] hor = new int[5];
			int[] vert = new int[5];
			hor[0] = hor[4] = 1;
			hor[1] = hor[3] = 4;
			hor[2] = 6;
			vert = hor;
			if (rb1.isSelected()) {
				matrix2 = Separabler_Filter(matrix1, hor, vert, 16, 16);	
			}
			else {
				matrix2 = Separabler_Filter(matrix2, hor, vert, 16, 16);
			}			
			p_filter.repaint();
			
                } // else if
	
/*		else if (e.getSource() == hochpass) {
                        System.out.println("Hochpass-Filter angewendet");
			thresholded = false;
			int [][] Kern = new int[3][3];
			Kern[0][0] = Kern[2][0] = Kern[0][2] = Kern[2][2] = 0;
			Kern[1][0] = Kern[0][1] = Kern[2][1] = Kern[1][2] = -1;
			Kern[1][1] = 5;
			if (rb1.isSelected()) {
				matrix2 = LinearerFilter(1, Kern, matrix1);	
			}
			else {
				matrix2 = LinearerFilter(1, Kern, matrix2);
			}				
			p_filter.repaint();
			
                } // else if
*/
		else if (e.getSource() == laplace) {
                        System.out.println("Laplace-Filter angewendet");
			thresholded = false;
			int [][] Kern = new int[3][3];
			Kern[0][0] = Kern[2][0] = Kern[0][2] = Kern[2][2] = 0;
			Kern[1][0] = Kern[0][1] = Kern[2][1] = Kern[1][2] = 1;
			Kern[1][1] = -4;
			if (rb1.isSelected()) {
				matrix2 = LinearerFilter(1, Kern, matrix1);	
			}
			else {
				matrix2 = LinearerFilter(1, Kern, matrix2);
			}				
			p_filter.repaint();
			
                } // else if
		
		else if (e.getSource() == h_sobel) {
                        System.out.println("H_Sobel-Filter angewendet");
			thresholded = false;
			int [][] Kern = new int[3][3];
			Kern[0][0] = Kern[2][0] = -1;
			Kern[0][1] = Kern[1][1] = Kern[2][1] = 0;
			Kern[1][0] = -2;
			Kern[0][2] = Kern[2][2] = 1;
			Kern[1][2] = 2;
			if (rb1.isSelected()) {
				matrix2 = LinearerFilter(8, Kern, matrix1);	
			}
			else {
				matrix2 = LinearerFilter(8, Kern, matrix2);
			}			
			p_filter.repaint();
			
                } // else if
		
		else if (e.getSource() == v_sobel) {
                        System.out.println("V_Sobel-Filter angewendet");
			thresholded = false;
			int [][] Kern = new int[3][3];
			Kern[0][0] = Kern[0][2] = -1;
			Kern[1][0] = Kern[1][1] = Kern[1][2] = 0;
			Kern[0][1] = -2;
			Kern[2][0] = Kern[2][2] = 1;
			Kern[2][1] = 2;
			if (rb1.isSelected()) {
				matrix2 = LinearerFilter(8, Kern, matrix1);	
			}
			else {
				matrix2 = LinearerFilter(8, Kern, matrix2);
			}			
			p_filter.repaint();
			
                } // else if

		else if (e.getSource() == nicht_sym) {
                        System.out.println("Unsymmetrischer-Filter angewendet");
			thresholded = false;
			int [][] Kern = new int[3][3];
			Kern[0][0] = Kern[0][1] = 0;
			Kern[1][0] = Kern[1][1] = Kern[2][0] = Kern[2][1] = 0;
			Kern[0][2] = Kern[2][2] = 0;
			Kern[1][2] = 1;	
			if (rb1.isSelected()) {
				matrix2 = LinearerFilter(1, Kern, matrix1);	
			}
			else {
				matrix2 = LinearerFilter(1, Kern, matrix2);
			}			
			p_filter.repaint();
			
                } // else if

		else if (e.getSource() == nicht_mittel) {
                        System.out.println("Nicht gemittelten Filter angewendet");
			thresholded = false;
			int [][] Kern = new int[3][3];
			Kern[0][0] = Kern[0][2] = 1;
			Kern[1][0] = Kern[1][1] = Kern[1][2] = 1;
			Kern[0][1] = 1;
			Kern[2][0] = Kern[2][2] = 1;
			Kern[2][1] = 1;
			if (rb1.isSelected()) {
				matrix2 = LinearerFilter(8, Kern, matrix1);	
			}
			else {
				matrix2 = LinearerFilter(8, Kern, matrix2);
			}			
			p_filter.repaint();
			
                } // else if

		else if (e.getSource() == median3) {
                        System.out.println("Median-Filter (3x3) angewendet");
			thresholded = false;
			if (rb1.isSelected()) {
				matrix2 = RangFilter("median", matrix1, 3);
			}
			else {
				matrix2 = RangFilter("median", matrix2, 3);
			}
			p_filter.repaint();
			
                } // else if

		else if (e.getSource() == median5) {
                        System.out.println("Median-Filter (5x5) angewendet");
			thresholded = false;
			if (rb1.isSelected()) {
				matrix2 = RangFilter("median", matrix1, 5);
			}
			else {
				matrix2 = RangFilter("median", matrix2, 5);
			}
			p_filter.repaint();
			
                } // else if

		else if (e.getSource() == minimum3) {
                        System.out.println("Minimum-Filter (3x3) angewendet");
			thresholded = false;
			if (rb1.isSelected()) {
				matrix2 = RangFilter("minimum", matrix1, 3);
			}
			else {
				matrix2 = RangFilter("minimum", matrix2, 3);
			}
			p_filter.repaint();
			
                } // else if

		else if (e.getSource() == minimum5) {
                        System.out.println("Minimum-Filter (5x5) angewendet");
			thresholded = false;
			if (rb1.isSelected()) {
				matrix2 = RangFilter("minimum", matrix1, 5);
			}
			else {
				matrix2 = RangFilter("minimum", matrix2, 5);
			}
			p_filter.repaint();
			
                } // else if

		else if (e.getSource() == maximum3) {
                        System.out.println("Maximum-Filter (3x3) angewendet");
			thresholded = false;
			if (rb1.isSelected()) {
				matrix2 = RangFilter("maximum", matrix1, 3);
			}
			else {
				matrix2 = RangFilter("maximum", matrix2, 3);
			}
			p_filter.repaint();
			
                } // else if

		else if (e.getSource() == maximum5) {
                        System.out.println("Maximum-Filter (5x5) angewendet");
			thresholded = false;
			if (rb1.isSelected()) {
				matrix2 = RangFilter("maximum", matrix1, 5);
			}
			else {
				matrix2 = RangFilter("maximum", matrix2, 5);
			}
			p_filter.repaint();
			
                } // else if

		else if (e.getSource() == mid_range3) {
                        System.out.println("Mid-Range-Filter (3x3) angewendet");
			thresholded = false;
			if (rb1.isSelected()) {
				matrix2 = RangFilter("mid_range", matrix1, 3);
			}
			else {
				matrix2 = RangFilter("mid_range", matrix2, 3);
			}
			p_filter.repaint();
			
                } // else if

		else if (e.getSource() == mid_range5) {
                        System.out.println("Mid-Range-Filter (5x5) angewendet");
			thresholded = false;
			if (rb1.isSelected()) {
				matrix2 = RangFilter("mid_range", matrix1, 5);
			}
			else {
				matrix2 = RangFilter("mid_range", matrix2, 5);
			}
			p_filter.repaint();
			
                } // else if

		else if (e.getSource() == bilat3) {
                        System.out.println("Bilateral-Filter (3x3) angewendet");
			thresholded = false;
			if (rb1.isSelected()) {
				matrix2 = Bilateralfilter(matrix1, 3);
			}
			else {
				matrix2 = Bilateralfilter(matrix2, 3);
			}
			p_filter.repaint();
			
                } // else if

		else if (e.getSource() == bilat5) {
                        System.out.println("Bilateral-Filter (5x5) angewendet");
			thresholded = false;
			if (rb1.isSelected()) {
				matrix2 = Bilateralfilter(matrix1, 5);
			}
			else {
				matrix2 = Bilateralfilter(matrix2, 5);
			}
			p_filter.repaint();
			
                } // else if
			
		else if (e.getSource() == info) {
			JOptionPane information = new JOptionPane();
			information.showMessageDialog(this, 
				" Dieses Programm wurde im Rahmen des Seminars 						\n SIMULATION UND BILDANALYSE MIT JAVA \n 						im WS 03/04 erstellt von Urs Pricking.",
				"Info", 1);
		} // else if	

		else if (e.getSource() == oeffnen) {
			System.out.println("Datei auswaehlen: ");
			if (Datei_auswaehlen(true)) {
				Datei_einlesen();
				Zeichnen();
			}
			
		} // else if

		else if (e.getSource() == speichern) {
			System.out.println("Datei auswaehlen: ");
			if (Datei_auswaehlen(false) && (frage == JOptionPane.YES_OPTION)) {
				Datei_schreiben();
				System.out.println("Datei gespeichert!");
			}
			else {
				System.out.println("Datei nicht gespeichert!");
			}
		} // else if


		else if (e.getSource() == schliessen) {
			System.out.println("Good bye!");
			System.exit(0);
		}		

       	 } // action Performed()

} //class Filteroperationen()
